;----------------------------------------------------------------------------
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;* Author: Sanjib Sharma                                                     *
;* Copyright (c) 2012 Sanjib Sharma                                          *
;* All rights reserved.                                                      *
;*                                                                           *
;* This file is part of EBF.  The full EBF copyright notice, including       *
;* terms governing use, modification, and redistribution, is contained in    *
;* the files COPYING and COPYRIGHT, which can be found at the root           *
;* of the source code distribution tree.                                     *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;-----------------------------------------------------------------------------
;+
; NAME:
;       EBF_containskey
;
; PURPOSE:
;       This function checks if a data item is present in a file
;
; CALLING SEQUENCE:
;       result=ebf_containskeys(filename,dataname)
;
; INPUTS:
;    filename- A string specifying the filename to read
;
; OUTPUT:
;       an array of strings
;
;
; EXAMPLE:
;       IDL> result=ebf_containskey("test.ebf","/x")
;
; MODIFICATION HISTORY:
;       Written, 1-March-2012, Sanjib Sharma
;-


function ebf_containskey,filename,dataname
  COMPILE_OPT STRICTARR,STRICTARRSUBS
  if ebftable_get(filename,dataname) ge 0 then return, 1 else return, 0
end


