;----------------------------------------------------------------------------
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;* Author: Sanjib Sharma                                                     *
;* Copyright (c) 2012 Sanjib Sharma                                          *
;* All rights reserved.                                                      *
;*                                                                           *
;* This file is part of EBF.  The full EBF copyright notice, including       *
;* terms governing use, modification, and redistribution, is contained in    *
;* the files COPYING and COPYRIGHT, which can be found at the root           *
;* of the source code distribution tree.                                     *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;-----------------------------------------------------------------------------


; 01223  9743033
function ctdiff,data1,data2,TAGNAMES=Tagnames
  status=0

  case size(data1,/type) of
     8: begin
        if ~keyword_set(Tagnames) then begin 
           temp=0.0
           for i=0,n_tags(data1)-1 do begin
              if size(data1,/type) eq 8 then begin
                 status1=ctdiff(data1.(i),data2.(i))
                 if status1 ne 1 then temp+=1
              endif else begin
                 temp+=abs(total(reform(data1.(i),n_elements(data1.(i))) eq reform(data2.(i),n_elements(data2.(i))))-n_elements(data1.(i)))
              endelse
           endfor
           if (n_tags(data1) eq n_tags(data2))and (temp eq 0) then temp=0.0

        endif else begin

           temp=0.0
           for i=0,n_elements(tagnames)-1 do begin
              temp+=abs(total(reform(data1.(i),n_elements(data1.(i))) eq reform(data2.(i),n_elements(data2.(i))))-n_elements(data1.(i)))
           endfor
        endelse
     end
     11: begin
        if obj_isa(data1,'hashtable') then begin
           keys=mydata->keys()
           temp=0.0
           for i=0,n_elements(keys)-1 do begin
              temp+=abs(total(reform(data1->get(keys[i]),n_elements(data1->get(keys[i]))) eq reform(data2->get(keys[i]),n_elements(data2->get(keys[i]))))-n_elements(data1->get(keys[i])))
           endfor
           if (data1->count() eq data2->count())and (temp eq 0) then temp=0.0
           print, data1->count(), data2->count(), temp 
        endif   

        if obj_isa(mydata,'hash') then begin
           keys=(mydata->keys())->toArray()
           temp=0.0
           for i=0,n_elements(keys)-1 do begin
              temp+=abs(total(reform(data1[keys[i]],n_elements(data1[keys[i]])) eq reform(data2[keys[i]],n_elements(data2[keys[i]])))-n_elements(data1[keys[i]]))
           endfor
           if (data1->count() eq data2->count())and (temp eq 0) then temp=0.0
        endif   
     end
     else: begin
        ;; if size(data1,/type) eq 7 then temp1=byte(data1) else temp1=data1
        ;; if size(data2,/type) eq 7 then temp2=byte(data2) else temp2=data2
        ;; temp=abs(total(reform(temp1,n_elements(temp1)) eq reform(temp2,n_elements(temp2)))-n_elements(temp1))
        temp=abs(total(reform(data1,n_elements(data1)) eq reform(data2,n_elements(data2)))-n_elements(data1))
     end
  endcase


  if temp eq 0 then status=1 
  
  return, status 
end

pro test_ebf
filename='test.ebf'
data={data_u1:bindgen(2,5),data_u2:uindgen(2,5)+1,data_u4:ulindgen(2,5)+2,data_u8:ul64indgen(2,5)+3,data_i2:indgen(2,5)+4,data_i4:lindgen(2,5)+5,data_i8:l64indgen(2,5)+6,data_f4:findgen(2,5)+7,data_f8:dindgen(2,5)+8}
outof=0
score=0
;----------------------------------------------------------
print,'TEST: general '
ebf_write,filename,'/data/',data,/nochar
ebf_write,filename,'/data/data1/',data,/append,/nochar
ebf_write,filename,'/datas',data,/append,/nochar
data1=0.0 & temp=0.0d
tagnames=tag_names(data)
tagnames1=tagnames
ebf_read,filename,'/data/',data1
ebf_read,filename,'/data/'+tagnames,data2,aliases=tagnames
ebf_read,filename,'/data/'+tagnames,data3,aliases=tagnames+'1'
ebf_read,filename,'/data/data1/'+tagnames,data4,aliases=tagnames
ebf_read,filename,'/datas',data5
ebf_read,filename,'/data/'+tagnames[0:5],data6
ebf_read,filename,'/data/data1/'+tagnames[6:*],data6,/append
;ebf_read,filename,'/data/data1/data_f*',data1,/append
status=1l
status=status*ctdiff(data,data1)
status=status*ctdiff(data,data2)
status=status*ctdiff(data,data3)
status=status*ctdiff(data,data4)
status=status*ctdiff(data,data5)
status=status*ctdiff(tagnames,tag_names(data1))
status=status*ctdiff(tagnames,tag_names(data2))
status=status*ctdiff(tagnames+'1',tag_names(data3))
status=status*ctdiff(tagnames,tag_names(data4))
status=status*ctdiff(tagnames,tag_names(data5))
status=status*ctdiff(tagnames,tag_names(data6))

if (n_tags(data1) eq n_tags(data))and (temp eq 0)and(status eq 1) then print,'->pass' else begin
print,'->fail'
status=0
endelse
outof++
score+=status
;----------------------------------------------------------

;----------------------------------------------------------
print,'TEST:reorder'
ebf_write,filename,'/data/',data,/REORDER,/nochar
data1=0.0 & temp=0.0d
ebf_read,filename,'/data/',data1,/REORDER
ebf_read,filename,'/data/',data2

x=findgen(2,3,4,5)
ebf_write,filename,'/x1',x,/nochar
ebf_write,filename,'/x1t',transpose(x),/append,/nochar
ebf_write,filename,'/x1r',x,/reorder,/append,/nochar

ebf_read,filename,'/x1t',x1
status*=ctdiff(transpose(x),x1)
ebf_read,filename,'/x1r',x1
status*=ctdiff(transpose(x),x1)
ebf_read,filename,'/x1t',x1,/reorder
status*=ctdiff(x,x1)
ebf_read,filename,'/x1t',x1,/reorder
status*=ctdiff(x,x1)
status*=ctdiff(data,data1)
if status eq 1 then print,'->pass' else print,'->fail'
outof++
score+=status
;----------------------------------------------------------
print,'TEST: case in-sensitiveness'
x=findgen(10)+100
ebf_write,filename,'/abc1',x,/nochar
ebf_read,filename,'/ABC1',y
status=ctdiff(x,y)
if status eq 1 then print,'->pass' else print,'->fail'
outof++
score+=status
;----------------------------------------------------------



print,'TEST:read multiple items into a stucture, deletes previous structure'
ebf_write,filename,'/data/',data,/nochar
ebf_write,filename,'/data/data1/',data,/append,/nochar
data1={x:0,y:0,z:0}
ebf_read,filename,['/data/data_u1','/data/data1/data_f4'],data1,aliases=['x','y']
status=1
status*=ctdiff(data.data_u1,data1.x)
status*=ctdiff(data.data_f4,data1.y)
if (n_tags(data1) eq 2)and(status eq 1) then print,'->pass' else begin 
print,'->fail'
status=0
endelse
outof++
score+=status
;----------------------------------------------------------


print,'TEST:read append if input not a structure deletes it'
ebf_write,filename,'/data/',data,/nochar
ebf_write,filename,'/data/data1/',data,/append,/nochar
data1=0.0
ebf_read,filename,'/data/data_u1',data1,/append
ebf_read,filename,'/data/data_f4',data1,/append
status=1
status*=ctdiff(data.data_u1,data1.data_u1)
status*=ctdiff(data.data_f4,data1.data_f4)
if (n_tags(data1) eq 2)and(status eq 1) then print,'->pass' else begin
print,'->fail'
status=0
endelse
outof++
score+=status
;----------------------------------------------------------
print,'TEST:write and read structures'
ebf_write,filename,'/data',data,/nochar
data1=0.0 & temp=0.0d
ebf_read,filename,'/data',data1
status=1
status*=ctdiff(data,data1)
if (n_tags(data1) eq n_tags(data))and (status eq 1) then print,'->pass' else begin 
print,'->fail'
status=0
endelse
outof++
score+=status
;----------------------------------------------------------

print,'TEST:write and read nested structures'
mystruct2={x:findgen(10)+2,y:findgen(10)+2}
mystruct1={x:dindgen(10)+1,y:dindgen(10)+1,z:dindgen(10)+1,mystr2:mystruct2}
mystruct0={x:findgen(10),y:findgen(10),mystr1:mystruct1}
ebf_write,'teststruct.ebf','/mystruct',mystruct0,/nochar
ebf_read,'teststruct.ebf','/mystruct',mystruct
status=1
status*=ctdiff(mystruct0.mystr1.mystr2.x,mystruct.mystr1.mystr2.x)
status*=ctdiff(mystruct0.mystr1.mystr2.y,mystruct.mystr1.mystr2.y)
status*=ctdiff(mystruct0.mystr1.x,mystruct.mystr1.x)
status*=ctdiff(mystruct0.mystr1.y,mystruct.mystr1.y)
status*=ctdiff(mystruct0.mystr1.z,mystruct.mystr1.z)
status*=ctdiff(mystruct0.x,mystruct.x)
status*=ctdiff(mystruct0.y,mystruct.y)

if status eq 1 then print,'->pass' else print,'->fail'
outof++
score+=status
;----------------------------------------------------------

print,'TEST:write and read specific tagnames only'
x=findgen(10) & y=findgen(10)+1 & z=findgen(10)+2
mystruct1={x:x,y:y,z:z}
ebf_write,'test.ebf','/foo/',mystruct1,tagnames=["x","z"],/nochar
ebf_read,'test.ebf','/foo/'+["x","z"],mystruct2,aliases=['x','z']
status=1
status*=ctdiff(mystruct1.x,mystruct2.x)
status*=ctdiff(mystruct1.z,mystruct2.z)
if status eq 1 then print,'->pass' else print,'->fail'
outof++
score+=status
;----------------------------------------------------------


print,'TEST:write and read specific tagnames only, but write with aliases'
x=findgen(10) & y=findgen(10)+1 & z=findgen(10)+2
mystruct1={x:x,y:y,z:z}
ebf_write,'test.ebf','/foo/',mystruct1,tagnames=["x","z"],aliases=['x1','z1'],/nochar
ebf_read,'test.ebf','/foo/'+["x1","z1"],mystruct2,aliases=['x2','z2']
status=1
status*=ctdiff(mystruct1.x,mystruct2.x2)
status*=ctdiff(mystruct1.z,mystruct2.z2)
if status eq 1 then print,'->pass' else print,'->fail'
outof++
score+=status
;----------------------------------------------------------


print,'TEST:SPLIT and auto handling of transposed data'
x=findgen(10,3) & y=findgen(10,3)
ebf_write,'test.ebf','/pos3',x,/nochar
ebf_write,'test.ebf','/vel3',transpose(y),/append,/nochar
ebf_read,'test.ebf','/pos3',halo1,/split,/append
ebf_read,'test.ebf','/vel3',halo2,/split,/append
status=ctdiff(halo1.px,halo2.vx)
if status eq 1 then print,'->pass' else print,'->fail'
outof++
score+=status




print,'TEST:read multiple items into a hashtable, deletes previous hashtable'
ebf_write,filename,'/data/',data,/nochar
ebf_write,filename,'/data/data1/',data,/append,/nochar
data1=obj_new('hashtable')
data1->add,'x1',1
data1->add,'x2',1
print,size(data1,/type)
ebf_read,filename,['/data/data_u1','/data/data1/data_f4'],data1,aliases=['x','y']
status=1
status*=ctdiff(data.data_u1,data1->get('x'))
status*=ctdiff(data.data_f4,data1->get('y'))
if (data1->count() eq 2)and(status eq 1) then print,'->pass' else begin 
print,'->fail'
status=0
endelse
obj_destroy,data1
outof++
score+=status


print,'TEST:read append if input not a hashtable deletes it'
ebf_write,filename,'/data/',data,/nochar
ebf_write,filename,'/data/data1/',data,/append,/nochar
data1=obj_new('hashtable')
ebf_read,filename,'/data/data_u1',data1,/append
ebf_read,filename,'/data/data_f4',data1,/append
status=1
status*=ctdiff(data.data_u1,data1->get('data_u1'))
status*=ctdiff(data.data_f4,data1->get('data_f4'))
if (data1->count() eq 2)and(status eq 1) then print,'->pass' else begin 
print,'->fail'
status=0
endelse
outof++
score+=status


print,'TEST:read append if input not a hash deletes it'
datah=obj_new('hashtable')
tags=tag_names(data)
for i=0,n_elements(tags)-1 do begin
datah->add,tags[i],data.(i)
endfor
ebf_write,filename,'/data/',datah,/nochar
ebf_write,filename,'/data/data1/',datah,/append,/nochar
data1=0
ebf_read,filename,'/data/',data1
data2=0
ebf_read,filename,'/data/data1/',data2,/append
status=1
status*=ctdiff(data.data_u1,data1.data_u1)
status*=ctdiff(data.data_f4,data1.data_f4)
status*=ctdiff(data.data_u1,data2.data_u1)
status*=ctdiff(data.data_f4,data2.data_f4)
if (n_tags(data1) eq n_tags(data))and (n_tags(data2) eq n_tags(data))and(status eq 1) then print,'->pass' else begin 
print,'->fail'
print, n_elements(data1), n_elements(data),  n_elements(data2), status
status=0
endelse
obj_destroy,datah
outof++
score+=status


print,'TEST:units'
datah=obj_new('hashtable')
tags=tag_names(data)
for i=0,n_elements(tags)-1 do begin
datah->add,tags[i],data.(i)
endfor
units=strarr(n_tags(data))+'100*km/s'
units[0]='m/s'
ebf_write,filename,'/datah/',datah,dataunit=units
ebf_write,filename,'/datas/',data,/append,dataunit=units

dataunit1=create_struct(tags[0],units[0])
for i=1,n_elements(tags)-1 do begin
dataunit1=create_struct(dataunit1,tags[i],units[i])
endfor
ebf_write,filename,'/struct/datas',data,dataunit=dataunit1,/append,/nochar
ebf_read,filename,'/datah/',data2,dataunit=units1
ebf_read,filename,'/datas/',data3,dataunit=units2
ebf_read,filename,'/struct/datas',data4,dataunit=units3
status=1

if (n_tags(units1)+n_tags(units2)+n_tags(units3)) ne n_elements(units)*3 then status=0
;if (total(units eq units1) ne n_elements(units)) or (total(units eq units) ne n_elements(units)) or (units3 ne units[0]) then status=0
;if (total(units eq units1) ne n_elements(units)) or (total(units eq units) ne n_elements(units))  then status=0

for i=0,n_tags(dataunit1)-1 do begin
if (units3.(i) ne dataunit1.(i)) then status=0
if (units2.(i) ne dataunit1.(i)) then status=0
if (units1.(i) ne dataunit1.(i)) then status=0
endfor

if status eq 1 then print,'->pass' else print,'->fail'
obj_destroy,datah
outof++
score+=status




if !VERSION.release ge 8 then begin

print,'TEST:read multiple items into a hash, deletes previous hashtable'
ebf_write,filename,'/data/',data,/nochar
ebf_write,filename,'/data/data1/',data,/append,/nochar
data1=obj_new('hash')
data1['x1']=1
data1['x2']=1
ebf_read,filename,['/data/data_u1','/data/data1/data_f4'],data1,aliases=['x','y']
status=1
status*=ctdiff(data.data_u1,data1['x'])
status*=ctdiff(data.data_f4,data1['y'])
if (n_elements(data1) eq 2)and(status eq 1) then print,'->pass' else begin 
print,'->fail'
status=0
endelse
outof++
score+=status


print,'TEST:read append if input not a hash deletes it'
ebf_write,filename,'/data/',data,/nochar
ebf_write,filename,'/data/data1/',data,/append,/nochar
data1=obj_new('hash')
ebf_read,filename,'/data/data_u1',data1,/append
ebf_read,filename,'/data/data_f4',data1,/append
status=1
status*=ctdiff(data.data_u1,data1['data_u1'])
status*=ctdiff(data.data_f4,data1['data_f4'])
if (n_elements(data1) eq 2)and(status eq 1) then print,'->pass' else begin 
print,'->fail'
status=0
endelse
outof++
score+=status


print,'TEST:read append if input not a hash deletes it'
datah=obj_new('hash')
tags=tag_names(data)
for i=0,n_elements(tags)-1 do begin
datah[tags[i]]=data.(i)
endfor
ebf_write,filename,'/data/',datah,/nochar
units=strarr(n_tags(data))+'100 km/s'
ebf_write,filename,'/data/data1/',datah,/append,dataunit=units
data1=0
ebf_read,filename,'/data/',data1
data2=0
ebf_read,filename,'/data/data1/',data2,/append,dataunit=units1
status=1
status*=ctdiff(data.data_u1,data1.data_u1)
status*=ctdiff(data.data_f4,data1.data_f4)
status*=ctdiff(data.data_u1,data2.data_u1)
status*=ctdiff(data.data_f4,data2.data_f4)
if (n_tags(data1) eq n_tags(data))and (n_tags(data2) eq n_tags(data))and(status eq 1) then print,'->pass' else begin 
print,'->fail'
print, n_elements(data1), n_elements(data),  n_elements(data2), status
status=0
endelse
obj_destroy,datah
outof++
score+=status

endif


;ebfdatadir='/home/sharma/sw/share/ebf/'
ebfdatadir=''
status=1
ebf_read,ebfdatadir+'master_test1.ebf','/',data1
ebf_read,ebfdatadir+'master_test1_swap.ebf','/',data2
status*=ctdiff(data1,data2)
if (n_elements(data1) ne n_elements(data2)) then status=0
if status eq 1 then print,'->pass' else print,'->fail'
outof++
score+=status


nsize=128
x1 =bindgen(128)
x2=-65636L-lindgen(128)
x3=-4294967296LL-l64indgen(128)
x4 = linspace1(1.23e20, 128.23e20,nsize)
x5 = linspace1(1.23456789d200, 128.23456789d200,nsize)
x6=-256-indgen(128)
x9 = byte(bindgen(128)-128)
x10=byte(bindgen(128)+128)
x11=uindgen(128)+256U
x12=ulindgen(128)+65636UL
x13=ul64indgen(128)+4294967296ULL
data={x1:x1,x2:x2,x3:x3,x4:x4,x5:x5,x6:x6,x9:x9,x10:x10,x11:x11,x12:x12,x13:x13}

diff=total(abs(data.x4/data1.x4-1),/double)
if ( diff gt 1e-5) then status=0
diff=total(abs(data.x5/data1.x5-1),/double)
if ( diff gt 1e-10) then status=0

data3={x1:byte(data1.x1),x2:data1.x2,x3:data1.x3,x4:data1.x4,x5:data1.x5,x6:data1.x6,x9:data1.x9,x10:data1.x10,x11:data1.x11,x12:data1.x12,x13:data1.x13}
data3.x4=1 & data3.x5=1 
data.x4=1 & data.x5=1
status*=ctdiff(data3,data)

if status eq 1 then print,'->pass' else print,'->fail'
outof++
score+=status


ebf_read,ebfdatadir+'header256.ebf','/',data
z=lindgen(10)
diff=total(abs(data.xvar-z),/double)
diff=diff+total(abs(data.yvar-z-10),/double)
if ( diff gt 1e-10) then status=0 else status=1
outof++
score+=status

data={x1:x1[0],x2:x2[0],x3:x3[0],x4:x4[0],x5:x5[0],x6:x6[0],x9:x9[0],x10:x10[0],x11:x11[0],x12:x12,x13:x13[0]}
ebf_write,'test.ebf','/',data,/nochar
ebf_read,'test.ebf','/',data1
ebf_info,'test.ebf'
status=ctdiff(data1,data)
if status eq 1 then print,'->pass' else print,'->fail'
outof++
score+=status

;; data={x1:x1[0],x2:x2[0],x3:x3[0],x4:x4[0],x5:x5[0],x6:x6[0],x9:x9[0],x10:x10[0],x11:x11[0],x12:x12,x13:x13[0]}
;; ebf_write,'/home/sharma/sw/share/ebf/scalar.ebf','/',data
;; ebf_read,'/home/sharma/sw/share/ebf/scalar.ebf','/',data1
;; ebf_info,'test.ebf'
;; status=ctdiff(data1,data)
;; if status eq 1 then print,'->pass' else print,'->fail'
;; outof++
;; score+=status




print,'Test Score=',score, ' out of ',outof 
end

pro check_checkSum
x1=fltarr(10)
x2=dblarr(10)
ebf_write,'check.ebf','/x1',x1
ebf_write,'check.ebf','/x2',x2,/append
ebf_write,'check.ebf','/single/x1',x1[0],/append
ebf_write,'check.ebf','/single/x2',x2[0],/append
ebf_read,'check.ebf','/.ebf/info',checksum
print,'checksum=',checksum[0],' last time was -6476246164911187085'
ebf_info,'check.ebf'
end


PRO printSpeed,s,t,nsize,KOPS=kops
if keyword_set(KOPS) then begin 
print, s,'Size=',nsize,' Time=',t,' Speed=',nsize*1e-3/t,' KOPS' ,t*1e3/nsize
endif else begin
print, s,'Size=',nsize,' Time=',t,' Speed=',nsize*1e-6/t,' MB/s' 
endelse
end

function structdiff,data1,data2
status=1
tagnames=tag_names(data1)
for i=0,n_elements(tagnames)-1 do begin

if size(data1,/type) eq 8 then begin
status*=structdiff(data1.(i),data2.(i))
endif else begin
ctdiff
endelse

endfor
return,status
end

test_ebf
check_checksum


point={x:lindgen(3),v:lindgen(3)+1}
point_u={x:'u=km',v:'u=km/s'}
data={color:1.0,mag:2.0,point:replicate(point,5,2),name:byte('abcdef')}
data_u1={x0:'u=mag',x1:'u=mag',point:point_u,name:'u=NULL'}
data1=replicate(data,3,4)
ebf_write,'struct_v2.ebf','/data',data1,dataunit=data_u1
ebf_read,'struct_v2.ebf','/data',data2,dataunit=data_u2
status=1
status*=ctdiff(data1,data2)
status*=ctdiff(data_u1,data_u2)
if status eq 1 then print,'->pass' else print,'->fail'



;; nsize=1000L

;; t1=systime(1)
;; x=[1L]
;; name=strarr(nsize)
;; for i=0L,nsize-1 do begin
;; name[i]='/x'+string(i,format='(I05)')
;; endfor

;; t1=systime(1)
;; ebf_write,'test.ebf',name[0],x
;; for i=1L,nsize-1 do begin
;; ebf_write,'test.ebf',name[i],x,/append
;; endfor
;; printSpeed,'ebf write items',systime(1)-t1,nsize,/KOPS



;; j=0L
;; t1=systime(1)
;; for i=0L,nsize-1 do begin
;; ebf_read,'test.ebf',name[i],temp
;; j+=temp
;; endfor
;; printSpeed,'ebf locate items',systime(1)-t1,nsize,/KOPS
;; if j ne nsize then message,'read error'

;; stop
;; ebf_read,'test.ebf','/2d/x4',x
;; print,x
;; stop


end
