;----------------------------------------------------------------------------
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;* Author: Sanjib Sharma                                                     *
;* Copyright (c) 2012 Sanjib Sharma                                          *
;* All rights reserved.                                                      *
;*                                                                           *
;* This file is part of EBF.  The full EBF copyright notice, including       *
;* terms governing use, modification, and redistribution, is contained in    *
;* the files COPYING and COPYRIGHT, which can be found at the root           *
;* of the source code distribution tree.                                     *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;-----------------------------------------------------------------------------

function ebf_idl2ebftc,i,nochar=nochar
on_error,2
i1=i-i
if size(i1,/n_dimensions) eq 0 then begin
if keyword_set(nochar) then begin
if i eq 1 then i1=10
endif else begin
if i eq 1 then i1=1
endelse
if i eq 2 then i1=6
if i eq 3 then i1=2
if i eq 4 then i1=4
if i eq 5 then i1=5
if i eq 8 then i1=8
if i eq 12 then i1=11
if i eq 13 then i1=12
if i eq 14 then i1=3
if i eq 15 then i1=13
endif else begin
if keyword_set(nochar) then begin
ind=where(i eq 1,count) & if count gt 0 then i1[ind]=10 
endif else begin
ind=where(i eq 1,count) & if count gt 0 then i1[ind]=1 
endelse
ind=where(i eq 2,count) & if count gt 0 then i1[ind]=6 
ind=where(i eq 3,count) & if count gt 0 then i1[ind]=2 
ind=where(i eq 4,count) & if count gt 0 then i1[ind]=4 
ind=where(i eq 5,count) & if count gt 0 then i1[ind]=5 
ind=where(i eq 12,count) & if count gt 0 then i1[ind]=11 
ind=where(i eq 13,count) & if count gt 0 then i1[ind]=12 
ind=where(i eq 14,count) & if count gt 0 then i1[ind]=3 
ind=where(i eq 15,count) & if count gt 0 then i1[ind]=13 
endelse
if product(i1) eq 0 then begin 
print,'input code',i
print,'output code',i1
message,'Unknown datatype found'
endif
return, i1
end

function ebf_tostring,x,_EXTRA=_EXTRA
on_error,2
  return, strcompress(string(x,_EXTRA=_EXTRA),/remove_all)
end


function ebf_struct2sdef_v2,a,DATAUNIT=dataunit,Start=Start,nochar=nochar
on_error,2
tagnames=strlowcase(tag_names(a))
ind=[0]


if keyword_set(Start) then begin
s='ver-2 '+string(10b)+'<sdef>'+string(10b)+'anonymous,8,1,1'+ebf_tostring(n_tags(a),format='(",",I)')+string(10b) 
endif else begin 
s=''
endelse
for i=0,n_tags(a)-1 do begin


temps=tagnames[i]+','+ebf_tostring(ebf_idl2ebftc(size(a.(i),/type),nochar=nochar))+','+ebf_tostring(size(a[0].(i),/n_dimensions))
if size(a[0].(i),/n_dimensions) gt 0 then begin
temps+=','+strjoin(ebf_tostring(reverse(size(a[0].(i),/dimensions))),',')
endif 
temps+=','+ebf_tostring(n_tags(a.(i)))



if size(a.(i),/type) eq 8 then begin 
if keyword_set(dataunit) then unit1=dataunit.(i) else unit1=''
s+=temps+string(10b)
s+=ebf_struct2sdef_v2(a.(i),dataunit=unit1,nochar=nochar)
endif else begin
if keyword_set(dataunit) then unit1=','+dataunit.(i) else unit1=''
if (size(unit1,/type) eq 7) and (size(unit1,/n_dimensions) eq 0) then begin
s+=temps+unit1+string(10b)
endif else message='Ebf Error: unit is not a scalar string'
endelse

endfor
if keyword_set(Start) then begin
s+='</sdef>'+string(10b)
endif

if (size(s,/type) eq 7) and (size(s,/n_dimensions) eq 0) then return, s else message,'Ebf Error: sdef is not a scalar string'

end


function ebf_struct2sdef_v1,a,NAME=Name
on_error,2
typestring=['', 'char', 'int32', 'int64', 'float32', 'float64', 'int16', '', 'struct', 'int8', 'uint8', 'uint16', 'uint32', 'uint64']
tagnames=strlowcase(tag_names(a))
ind=[0]
if keyword_set(NAME) then s='' else s='ver-1 '+string(10b) 
s+='struct { '+string(10b)
for i=0,n_tags(a)-1 do begin
if size(a.(i),/type) eq 8 then begin 
s+=ebf_struct2sdef_v1(a.(i),NAME=tagnames[i])
endif else begin
if size(a[0].(i),/n_dimensions) gt 0 then begin
temps=string(size(a[0].(i),/n_dimensions))+' '+strjoin(string(reverse(size(a[0].(i),/dimensions))),' ')
endif else temps=string(size(a[0].(i),/n_dimensions))
s+=string(typestring[ebf_idl2ebftc(size(a.(i),/type))])+' '+tagnames[i]+' '+temps+" ; "+string(10b)
endelse
endfor
s+=' } '

if keyword_set(NAME) then myname=name else myname='anonymous' 
if size(a,/n_dimensions) gt 0 then begin
temps=string(size(a,/n_dimensions))+' '+strjoin(string(reverse(size(a,/dimensions))),' ')
endif else temps=string(size(a,/n_dimensions))
s+=myname+' '+temps+' ; '+string(10b)

return, s
end

function ebf_struct2sdef,data,dataunit=dataunit,nochar=nochar
on_error,2
return, ebf_struct2sdef_v2(data,/start,dataunit=dataunit,nochar=nochar)
;return, ebf_struct2sdef_v1(data)
end





pro ebfheader_set,ebfh,name,data,REORDER=Reorder,DATAUNIT=Dataunit,DTYPE=dtype,nochar=nochar
on_error,2
  keyword=''
  value=''
  dataunit1=''  
  if keyword_set(Dataunit) then dataunit1=Dataunit 
  if (size(data[0],/type) eq 8) then begin 
     dataunit1=''
     sdef1=ebf_struct2sdef(data[0],dataunit=dataunit,nochar=nochar)
  endif else begin
     sdef1=''
  endelse
  ebfh={endiantest:0L,datatype:0L,datasize:0L,rank:0L,headersize:0L,name:strlowcase(name),dataunit:dataunit1,capacity:0LL,flags:bytarr(4),sdef:sdef1,flagswap:0L}

  datasize=[0,1,4,8,4,8,2,2,0,1,1,2,4,8]
  ebfh.datatype=ebf_idl2ebftc(size(data,/type),nochar=nochar) 
  if keyword_set(dtype) then ebfh.datatype=dtype 
  ebfh.datasize=datasize[ebfh.datatype] 
  if ebfh.datatype eq 8 then ebfh.datasize=n_tags(data[0],/data_length)
  if keyword_set(REORDER)and(ebfh.datatype eq 8) then message,'A structure array cannot be  transposed'
  ebfh.rank=size(data,/N_dimensions)

  if ebfh.rank eq 0 then begin 
     ebfh.rank=1
     dim=[long64(size(data,/n_elements))]
  endif else begin
     if keyword_set(REORDER) then dim=long64(size(data,/dimensions)) else dim=long64(reverse(size(data,/dimensions)))
  endelse

          
  if ebfh.rank eq 0 then begin
     ebfh=create_struct(ebfh,'dim',dim[0:0])
     ebfh.capacity=ebfh.datasize 
  endif else begin
     ebfh=create_struct(ebfh,'dim',dim[0:ebfh.rank-1])
     ebfh.capacity=ebfh.datasize*product(ebfh.dim[0:ebfh.rank-1],/integer) 
  endelse

  ebfh.headersize=long(56+n_elements(ebfh.name)+strlen(ebfh.dataunit)+strlen(ebfh.sdef)+ebfh.rank*8)
  if (ebfh.rank eq 1)and(ebfh.dim[0] eq 1) then ebfh.headersize+=16 else ebfh.headersize+=64


end
