;----------------------------------------------------------------------------
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;* Author: Sanjib Sharma                                                     *
;* Copyright (c) 2012 Sanjib Sharma                                          *
;* All rights reserved.                                                      *
;*                                                                           *
;* This file is part of EBF.  The full EBF copyright notice, including       *
;* terms governing use, modification, and redistribution, is contained in    *
;* the files COPYING and COPYRIGHT, which can be found at the root           *
;* of the source code distribution tree.                                     *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;-----------------------------------------------------------------------------

pro ebfheader_write,ebfh,lun
    endiantest=1684234849L
    if size(ebfh.name,/type) eq 1 then message,'correct set header'
    namesize=long(n_elements(byte(ebfh.name)))

    dataunit_size=0L
    sdef_size=0L
    if ebfh.dataunit ne "" then  dataunit_size=long(n_elements(byte(ebfh.dataunit)))
    if ebfh.sdef ne "" then  sdef_size=long(n_elements(byte(ebfh.sdef)))
    point_lun,-lun,pos1

    sig=[-118b,69b,66b,70b,-82b,43b,-81b,10b]
    version=[1b,1b,0b,0b]
    writeu,lun,sig
    writeu,lun,version
    if ebfh.flagswap eq 1 then begin 
       writeu,lun,swap_endian(endiantest)
       writeu,lun,swap_endian(ebfh.headersize)
       writeu,lun,swap_endian(namesize)
       writeu,lun,swap_endian(ebfh.datatype)
       writeu,lun,swap_endian(ebfh.datasize)
       writeu,lun,swap_endian(ebfh.rank)
       writeu,lun,swap_endian(dataunit_size)
       writeu,lun,swap_endian(sdef_size)
       writeu,lun,ebfh.flags
       writeu,lun,swap_endian(ebfh.capacity)
       if ebfh.rank gt 0 then writeu,lun,swap_endian(ebfh.dim[0:ebfh.rank-1])
    endif else begin
       writeu,lun,endiantest
       writeu,lun,ebfh.headersize
       writeu,lun,namesize
       writeu,lun,ebfh.datatype
       writeu,lun,ebfh.datasize
       writeu,lun,ebfh.rank
       writeu,lun,dataunit_size
       writeu,lun,sdef_size
       writeu,lun,ebfh.flags
       writeu,lun,ebfh.capacity
       if ebfh.rank gt 0 then writeu,lun,ebfh.dim[0:ebfh.rank-1]
    endelse
 
    writeu,lun,ebfh.name
    if dataunit_size gt 0 then writeu,lun,byte(ebfh.dataunit)
    if sdef_size gt 0 then begin 
       writeu,lun,byte(ebfh.sdef)
    endif   

    point_lun,-lun,pos2
    temp=ebfh.headersize-(pos2-pos1)
    if temp lt 0 then message,'Ebf error, something wrong with header, file will get corrupted'
    if temp gt 0 then begin 
       extra=bytarr(temp)+60b
       writeu,lun,extra
    endif

end


