; create-> write htable in end update /.ebf/info[1:2] with location 
; expand-> get (key,loc), rename /.ebf/create, put old 
; get   -> 
; put   ->
; header,table,nodes,string
;; ebftab={data:lonarr(4),hecode:0L,ecode:0L,flagswap:0L,dpos:-1L,}
;; node={keyloc:0LL,keysize:0LL,value:0LL,next:0LL,tnext:0LL}
;; header={version:bytarr(8),endiantest:0LL,headersize:0LL,datatypesize:0LL,hash_algo:0LL,current:0LL,htcapacity:0LL,itemsize:0LL,itempos:0LL,itemcapacity:0LL,keypos:0LL,keycapacity:0LL,keyposcur:0LL}
;; table=lonarr(header.htcapacity)
;; items=replicate(node,header.itemcapacity)

function ebftable_ebflthash,mystr,capacity
  COMPILE_OPT STRICTARR,STRICTARRSUBS
  ON_ERROR,2
  ehash=5381ULL
  y=ulong64(byte(mystr))
  for i=0ULL,n_elements(y)-1ULL do begin
     ehash=ehash*33ULL+y[i]
  endfor
  return,long64(ehash mod capacity) 
end


function ebftable_read_hvalue,lun,dinfo,header,hflagswap,i
  COMPILE_OPT STRICTARR,STRICTARRSUBS
  ON_ERROR,2
  point_lun,lun,dinfo[2]+header.headersize+header.datatypesize*i
  x=0LL
  readu,lun,x
  if hflagswap eq 1 then swap_endian_inplace,x 
  return,x
end

function ebftable_read_node,lun,dinfo,header,hflagswap,i
  COMPILE_OPT STRICTARR,STRICTARRSUBS
  ON_ERROR,2
  point_lun,lun,dinfo[2]+header.itempos+header.itemsize*i
  x={keyloc:0LL,keysize:0LL,value:0LL,next:0LL,tnext:0LL}
  readu,lun,x
  if hflagswap eq 1 then swap_endian_inplace,x 
  return,x
end

function ebftable_read_key,lun,dinfo,header,hflagswap,node
  COMPILE_OPT STRICTARR,STRICTARRSUBS
  ON_ERROR,2
  point_lun,lun,dinfo[2]+header.keypos+node.keyloc
  x=bytarr(node.keysize)
  readu,lun,x
  return, string(x)
end

pro ebftable_write_hvalue,lun,dinfo,header,hflagswap,i,value
  COMPILE_OPT STRICTARR,STRICTARRSUBS
  ON_ERROR,2
  point_lun,lun,dinfo[2]+header.headersize+header.datatypesize*i
  x=long64(value)
  if hflagswap eq 1 then swap_endian_inplace,x 
  writeu,lun,x
end

pro ebftable_write_node,lun,dinfo,header,hflagswap,i,value
  COMPILE_OPT STRICTARR,STRICTARRSUBS
  ON_ERROR,2
  point_lun,lun,dinfo[2]+header.itempos+header.itemsize*i
  x=value
  if hflagswap eq 1 then swap_endian_inplace,x 
  writeu,lun,x
end


pro ebftable_write_key,lun,dinfo,header,hflagswap,node,value
  COMPILE_OPT STRICTARR,STRICTARRSUBS
  ON_ERROR,2
  point_lun,lun,dinfo[2]+header.keypos+node.keyloc
  writeu,lun,byte(value)
end

pro ebftable_get_keyval,lun,dinfo,header,hflagswap,key,location
  COMPILE_OPT STRICTARR,STRICTARRSUBS
  ON_ERROR,2
  if (size(key))[0] eq 0 then location=-1LL else location=lon64arr(n_elements(key))-1LL
  for i=0LL,n_elements(key)-1 do begin
     keyhash=ebftable_ebflthash(key[i],header.htcapacity)
     loc1=ebftable_read_hvalue(lun,dinfo,header,hflagswap,keyhash)            
     if loc1 ne 0 then begin
        item1=ebftable_read_node(lun,dinfo,header,hflagswap,loc1)
        while (ebftable_read_key(lun,dinfo,header,hflagswap,item1) ne key[i]) and (item1.next ne -1) do begin
           item1=ebftable_read_node(lun,dinfo,header,hflagswap,item1.next)
        endwhile
        if ebftable_read_key(lun,dinfo,header,hflagswap,item1) eq key[i] then location[i]=item1.value
     endif
  endfor
end


pro ebftable_getkeyvalsHT,lun,dinfo,header,hflagswap,keys,values
  COMPILE_OPT STRICTARR,STRICTARRSUBS
  ON_ERROR,2
  keys=strarr(header.itemcapacity)
  values=lon64arr(header.itemcapacity)-1LL

; read all contents
  point_lun,lun,dinfo[2]+header.headersize
  hvalue=lon64arr(header.htcapacity)
  readu,lun,hvalue
  point_lun,lun,dinfo[2]+header.itempos
  node={keyloc:0LL,keysize:0LL,value:0LL,next:0LL,tnext:0LL}
  nodearr=replicate(node,header.itemcapacity)
  readu,lun,nodearr
  if hflagswap eq 1 then begin
     swap_endian_inplace,hvalue
     swap_endian_inplace,nodearr
  endif
  point_lun,lun,dinfo[2]+header.keypos
  keyarr=bytarr(header.keycapacity)
  readu,lun,keyarr

; extract key values
  j=0LL
  for i=0LL,header.htcapacity-1 do begin
     if hvalue[i] ne 0 then begin
        item1=nodearr[hvalue[i]]
        keys[j]=string(keyarr[item1.keyloc:(item1.keyloc+item1.keysize)-1])
        values[j]=item1.value
        j=j+1
        while item1.next ne -1 do begin
           item1=nodearr[item1.next]
           keys[j]=string(keyarr[item1.keyloc:(item1.keyloc+item1.keysize)-1])
           values[j]=item1.value
           j=j+1
        endwhile
     endif
  endfor
  keys=keys[0:j-1]
  values=values[0:j-1]
end


pro ebftable_getkeyvalsIT,lun,keys,values
  COMPILE_OPT STRICTARR,STRICTARRSUBS
  ON_ERROR,2
  point_lun,lun,0
  keys1=strarr(16)
  values1=lon64arr(16)
  nsize=0LL
  while ~EOF(lun) do begin
     point_lun,-lun,pos
     ebfheader_read,ebfh,lun
     print,ebfh.name
     if nsize eq n_elements(keys1) then begin
        keyst=keys1
        valuest=values1
        keys1=strarr(nsize*2)
        values1=lon64arr(nsize*2)
        keys1[0:nsize-1]=keyst
        values1[0:nsize-1]=valuest
     endif   
     keys1[nsize]=string(ebfh.name)
     values1[nsize]=pos
     nsize++
     point_lun,lun,pos+ebfh.capacity+ebfh.headersize
  endwhile 
  keys=keys1[0:nsize-1]
  values=values1[0:nsize-1]
  keys=strlowcase(keys)
end



pro ebftable_setup,fname,lun,dinfo,dinfo_pos,dflagswap,header,hflagswap,ecode,RONLY=ronly
  COMPILE_OPT STRICTARR,STRICTARRSUBS
  ON_ERROR,2
  header={version:bytarr(8),endiantest:0LL,headersize:0LL,datatypesize:0LL,hash_algo:0LL,current:0LL,htcapacity:0LL,itemsize:0LL,itempos:0LL,itemcapacity:0LL,keypos:0LL,keycapacity:0LL,keyposcur:0LL}
  ecode=0
  dinfo_dpos=-1LL
  hflagswap=0
  dflagswap=0
  if size(fname,/type) ne 7 then message,'Ebf Error: filename must be a string'

  if keyword_set(RONLY) then openr,lun,fname,error=err,/get_lun  else openu,lun,fname,error=err,/get_lun

  if err ne 0 then begin
     ecode=1000
     print,'file not found: '+fname
  endif else begin
; read dinfo
     point_lun,lun,0L
     ebfheader_read,ebfh_dinfo,lun
     elements=product(ebfh_dinfo.dim,/integer)
     if ((ebfh_dinfo.name eq '/.ebf/info')and(elements ge 4)and(ebfh_dinfo.datatype eq 3)) then begin 
        dinfo=lon64arr(elements)
        point_lun,-lun,dinfo_pos
        readu,lun,dinfo
        if ebfh_dinfo.flagswap eq 1 then begin
           swap_endian_inplace,dinfo
           dflagswap=1
        endif

; read header
        if ((dinfo[1] gt 0)and(dinfo[2] gt 0)and(dinfo[3] eq 1)) then begin
           point_lun,lun,dinfo[2]
           readu,lun,header
           if header.endiantest ne 1684234849 then begin 
              swap_endian_inplace,header
              hflagswap=1
           endif
           if (header.version[0] ne 1)or(header.endiantest ne 1684234849) then ecode=11
        endif else ecode=12
     endif else ecode=100  
  endelse   

end








